'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };







var stringify = function stringify(val) {
  return typeof val === 'string' ? val : JSON.stringify(val);
};

var stringifyOptions = function stringifyOptions(opts) {
  return Object.keys(opts).filter(function (key) {
    return (/^(?:expires|path|domain|secure)$/i.test(key)
    );
  }).reduce(function (memo, key) {
    return memo + '; ' + key + '=' + opts[key];
  }, '');
};

var isObject = function isObject(val) {
  return val !== null && (typeof val === 'undefined' ? 'undefined' : _typeof(val)) === 'object' && val instanceof Object;
};

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* setters */
var set = function set(key, val) {
  var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var cookies = isObject(key) ? key : _defineProperty({}, key, val);
  opts = stringifyOptions(opts);

  Object.keys(cookies).forEach(function (key) {
    document.cookie = key + '=' + stringify(cookies[key]) + '; ' + opts;
  });

  return Promise.resolve();
};

/* getters */
var get = function get(key) {
  var match = document.cookie.match(new RegExp('(' + key + ')=(.*?)(;|$)'));

  return Promise.resolve(match ? match[2] : undefined);
};

var getAll = function getAll() {
  var cookies = {};

  document.cookie.replace(/; /g, ';').split(';').map(function (cookie) {
    return cookie.split('=');
  })
  // Filters only those who has a non-empty key (happens when you delete one)
  .filter(function (_ref2) {
    var _ref3 = _slicedToArray(_ref2, 1),
        key = _ref3[0];

    return key;
  }).forEach(function (_ref4) {
    var _ref5 = _slicedToArray(_ref4, 2),
        key = _ref5[0],
        val = _ref5[1];

    return cookies[key] = val;
  });

  return Promise.resolve(cookies);
};

/* removers */
var remove = function remove(key) {
  document.cookie = key + '=; expires=Thu, 01 Jan 1970 00:00:01 GMT;';

  return Promise.resolve();
};

var clearAll = function clearAll() {
  document.cookie.replace(/; /g, ';').split(';').map(function (cookie) {
    return cookie.split('=')[0];
  }).forEach(remove);

  return Promise.resolve();
};

/* Used only for tests, it's private, don't use it */
var _mock = function _mock(cookies) {
  Object.keys(cookies).forEach(function (key) {
    document.cookie = key + '=' + stringify(cookies[key]);
  });

  return Promise.resolve();
};

var _platform = 'browser';

var browser = { set: set, get: get, getAll: getAll, remove: remove, clearAll: clearAll, _mock: _mock, _platform: _platform };

module.exports = browser;
